//****************************************************************************
// FileName : WDLIB.C
// Function : WDT Function Define of Include File(For SMSC SCH3112-NU)
// Design's : By Damon
// BuildDate: 04/15/2013 V1.0
//****************************************************************************

//Include file as follows:
#include <wdlib.h>
#include <stdio.h>
#include <conio.h>

//==========================================================================//
// INITWDT                                                                                                                                                         //
//==========================================================================//
//Function:Initial Watch-Dog
//Input: 	SetWdtTriggerType=> 	Select the Watch-Dog Timeout Event.
//				0x80: Generate an interrupt when the WDT time-out.
//				0x0C: Reset system when the WDT time-out.
//          	SetWdtTimeUnit=>		Set the Watch-Dog timer unit.
//				0x00:Minutes
//				0x01:Sceonds
//	SetWdtIRQMap=>		Watch-Dog interrupt mapping, this parameter is valid when
//				the Watch-Dog Timeout Event is set to generate an interrupt.
//				0xF0:IRQ15
//				        :
//				0x30:IRQ3
//				0x20:IRQ2
//				0x10:IRQ1
//				0x00:Disable
//Return:	None
//========================================================================== //
void INITWDT(char SetWdtTriggerType,char SetWdtTimeUnit,char SetWdtIRQMap)
{
	outportb(0x668,(inportb(0x668) & 0xfe));  
	outportb(0x647,SetWdtTriggerType);
	if(SetWdtTriggerType==0x08)
	{
		outportb(0x667,SetWdtIRQMap);
		}
	outportb(0x665,SetWdtTimeUnit);
}		

//==========================================================================//
// ENWDT                                                                                                                                                            //
//==========================================================================//
// Function : Enable Watch-Dog                                                                                                                 
// Input       : WdtValue=>	The Watch-dog Timer Time-out Value     
//			00  Time-out disable
//			01  time-out = 1 minutes (second)
//			KK.
//			FF  time-out = 255 minutes (second)
//
// Return     :NONE                                                                                                                                            
//========================================================================== //
void ENWDT(char WdtValue)
{
	outportb(0x668,(inportb(0x668) & 0xfe));
	outportb(0x666,WdtValue);
}

//==========================================================================//
// DISWDT                                                                                                                                                           //
//==========================================================================//
// Function : Disable Watch-Dog                                                                                                               //     
// Input        : NONE                                     																					                //
// Return     : NONE                                                                                                                                          //
//==========================================================================//
void DISWDT()
{
	outportb(0x668,(inportb(0x668) & 0xfe));
	outportb(0x666,0x00);
	outportb(0x667,0x00);
}
	